module Api
  class ApiObject

    #
    # static methods
    #

    protected
    def self.logger
      if @logger.nil?
        @logger = AppInfo.instance.logger
      end

      @logger
    end


    #
    # Properties
    #

    public
    attr_accessor :request_id

    #
    # Methods
    #

    # default constructor
    public
    def initialize(request_id = nil)
      @request_id = request_id || -1
    end


    if Rails.env.development?
      public
      def report_log(action)
        ApiObject.logger.info "request_id:\t\t#{self.request_id}\t\t#{action} #{self.class}"
      end
    else
      public
      def report_log(action)
      end
    end

  end
end