module Api
  class RequestPlatformBase < RequestBase

    #
    # Properties
    #

    public
    def platform_info=(value)
      @platform_info_compressed = value
    end

    public
    def is_compressed=(value)
      @is_compressed = value
    end

    public
    def platform_info
      if @platform_info.nil?
        @platform_info = @is_compressed ? get_platform_info_uncompressed : @platform_info_compressed

        @platform_info.recursive_symbolize_keys!
      end

      @platform_info
    end

    #
    # Methods
    #

    # default constructor
    public
    def initialize(options = nil)
      super(options)

      @platform_info_compressed = nil
      @platform_info            = nil
      @is_compressed            = false
    end

    private
    def get_platform_info_uncompressed
      # we use base64 encoding  instead string because as3 have troubles with reading binary to string from byte array
      # we use base64 encoding instead byte array because js have troubles with sending byte array
      platform_info_json = UtilsZip.decompress_base64(@platform_info_compressed)

      result = JSON.parse(platform_info_json)

      result
    end
  end
end