# See the wiki for details:
# https://github.com/CanCanCommunity/cancancan/wiki/Defining-Abilities
require 'cancan'

class Ability
  include CanCan::Ability

  public
  def self.rails_admin_config=(value)
    @rails_admin_config = value
  end

  public
  def self.rails_admin_config
    @rails_admin_config
  end

  def initialize(user)
    models_can_manage = self.class.rails_admin_config.get_models_can_manage_for(user.role)

    can :access, :rails_admin # only allow admin users to access Rails Admin
    can :dashboard # allow access to dashboard
    can :manage, models_can_manage
    #use if need
    # cannot :manage, models_cannot_manage
  end
end