class AppConfigBase < ModelBase

  include Mongoid::Document
  prepend MongoidIdAlias

  #
  # callbacks
  #

  after_save :update_config

  #
  # db
  #

  store_in collection: 'app_config'

  #
  # fields
  #

  field :server_name, type: String
  field :host, type: String

  field :server_on_maintenance, type: Boolean, default: false

  #
  # Properties
  #

  #
  # Methods
  #

  # default constructor
  def initialize(options = nil)
    super(options)
  end

  private
  def update_config
    AppInfo.instance.on_config_updated
  end

  #
  # validates
  #

  private
  def check_uniq
    if AppConfigBase.where(:id.ne => self.id).exists?
      self.errors.add(:base, 'app config already exist')
    end
  end

  validate :check_uniq

end