class ManagerBase

  #
  # Properties
  #

  public
  def info
    {}
  end

  #
  # Events
  #

  public
  def on_server_shutdown

  end

  # calls at fourth
  public
  def on_data_loaded

  end

  # calls at last
  public
  def on_server_started

  end

  public
  def on_server_maintenance_on

  end

  public
  def is_ready_for_shutdown?
    true
  end

  #
  # Methods
  #

  # calls at first
  # default constructor
  def initialize(options = nil)
  end

  # calls at second
  public
  def post_init
    @logger = AppInfo.instance.logger

    nil
  end

  # calls at third
  public
  def load_init_data
    nil
  end

  # calls at fifth
  public
  def start_tasks
    nil
  end

  # calls each N minutes
  public
  def invalidate_cache
    nil
  end

  # calls each N minutes
  public
  def cleanup_data
  end

end