class ManagerBundlesBase < ManagerWithJsonData

  #
  # Properties
  #

  public
  attr_reader :build_type

  protected
  def data_client_folder
    "#{Constants::DIR_ASSETS_DYNAMIC}/data_client/bundles/#{@build_type}/"
  end

  protected
  def get_json_data_client
    result = {}

    bundles_map = {}

    bundles_list = get_bundles_list

    bundles_list.each do |bundle_info|
      bundles_map[bundle_info.name] = bundle_info.serialize
    end

    result[:bundles_map] = bundles_map

    result.to_json
  end


  #
  # Methods
  #

  # default constructor
  public
  def initialize(build_type)
    super

    @class_asset = BundleBase

    @build_type = build_type
  end

  private
  def get_bundles_list
    result = @class_asset.where(build_type: @build_type).to_a

    result.map!(&:create_info)

    result
  end

end