class Hash

  public
  def recursive_symbolize_keys!
    symbolize_keys!

    # symbolize each hash in .values
    values.each do |value|
      value.recursive_symbolize_keys! if value.is_a?(Hash)
    end
    # symbolize each hash inside an array in .values
    values.select { |value| value.is_a?(Array) }.flatten.each do |item|
      item.recursive_symbolize_keys! if item.is_a?(Hash)
    end

    self
  end

  public
  def get_value_or_default(key, default)
    result = self[key]

    if result.nil?
      result = default
    end

    result
  end

end