class ManagerScheduler < ManagerBase

  #
  # Properties
  #

  #example methods
  #in, every, unschedule, at
  attr_reader :scheduler

  public
  def is_ready_for_shutdown?
    result = false

    @actions_locker.synchronize do
      result = @actions.empty?
    end

    result
  end

  #
  # Methods
  #

  # default constructor
  public
  def initialize(options = nil)
    super(options)

    @scheduler = Rufus::Scheduler.new

    @actions = []

    @actions_locker = Mutex.new
  end

  public
  def start_tasks
    super

    create_background_tasks_thread

    nil
  end

  private
  def create_background_tasks_thread
    task = ThreadWithTask.new(0.1, 'thread_scheduler')

    task.run do
      action = nil

      @actions_locker.synchronize do
        action = @actions.shift
      end #synchronize

      next if action.nil?

      action.call

      nil
    end #task

    nil
  end

  public
  def run_in_background(*actions, &action_block)
    @actions_locker.synchronize do
      actions.each do |action|
        @actions << action
      end

      @actions << action_block if action_block
    end
  end

end