class StatisticApplicationBase < ModelBase

  include Mongoid::Document
  prepend MongoidIdAlias

  #
  # Static methods
  #

  public
  def self.configure_admin_list(section, field_name)

    case field_name
      when :_id
        section.configure field_name do
          visible false
        end

      when :date
        section.configure field_name do
          column_width 60
          #show field at the 1 place
          self.order = -2
        end

      when :platform_type
        section.configure field_name, :enum do
          enum do
            EPlatformType::values_list
          end
          column_width 60
          #show field at the 2 place
          self.order = -1
        end

      else
        section.configure field_name do
          column_width 60
        end
    end

  end

  public
  def self.filters_for_admin_list(section)
    section.filters [:platform_type]
  end

  #
  # db
  #

  store_in collection: 'statistics_application'

  #
  # fields
  #

  field :date, type: String
  field :platform_type, type: String
  field :dau, type: Integer
  field :installs, type: Integer
  field :paid_users, type: Integer
  field :revenue, type: Integer
  field :arpu, type: Float
  field :arppu, type: Float

  field :ret_1d, type: Float
  field :ret_3d, type: Float
  field :ret_7d, type: Float
  field :ret_14d, type: Float

  #
  # add_indexes
  #

  index(date: 1)

  #
  # Methods
  #

  # default constructor
  def initialize(options = nil)
    super(options)
  end

end