class SystemHandlerProfiler < ModelBase

  include Mongoid::Document
  prepend MongoidIdAlias

  #
  # Static methods
  #

  public
  def self.configure_admin_list(section, field_name)

    case field_name
      when :_id, :requests_handle_duration_ms
        section.configure field_name do
          visible false
        end

      when :requests_count
        section.configure field_name do
          column_width 80
        end

      when :requests_handle_duration_max
        section.configure field_name do
          label 'Duration max'
          column_width 80
        end

      when :requests_handle_duration_min
        section.configure field_name do
          label 'Duration min'
          column_width 80
        end

      when :requests_handle_duration_avg
        section.configure field_name do
          label 'Duration avg'
          column_width 80
        end

      when :timestamp
        section.configure field_name do
          column_width 120
        end
      else
        super(section, field_name)
    end

  end

  #
  # db
  #

  store_in collection: 'system_handler_profiler'

  #
  # fields
  #

  field :handler, type: String
  field :requests_count, type: Integer

  field :requests_handle_duration_ms, type: Integer
  field :requests_handle_duration_avg, type: Integer
  field :requests_handle_duration_max, type: Integer
  field :requests_handle_duration_min, type: Integer

  field :timestamp, type: Integer

  #
  # Properties
  #

  #
  # Methods
  #

  # default constructor
  def initialize(options = nil)
    super
  end

end