module Utils
  module Mongo

    class << self

      def create_capped_collection(collection, size, max = 10_000_000)
        Mongoid::Clients.default.command(create: collection, capped: true, size: size, max: max)
      end

      def get_collection_stats(collection)
        Mongoid::Clients.default.command(collStats: collection) rescue nil
      end

      def get_database_stats
        Mongoid::Clients.default.command(dbStats: 1) rescue nil
      end

      def get_collection_storage_size(collection)
        get_collection_stats_property(collection, 'storageSize')
      end

      def get_collection_data_size(collection)
        get_collection_stats_property(collection, 'size')
      end

      def get_collection_stats_property(collection, property)
        result = nil

        stats = get_collection_stats(collection)

        if !stats.nil? && !stats.first.nil?
          result = stats.first[property]
        end

        result
      end

    end

  end
end