module UtilsURL

  public
  def self.to_path_absolute(path_relative)
    result = ''

    if path_relative.nil?
      puts 'UtilsURL::to_path_absolute arg is nil'
      return result
    end

    protocol = Rails.env.development? ? 'http://' : 'https://'

    result = File.join(protocol, AppInfo.instance.host, path_relative)

    result
  end

  public
  def self.to_path_relative(path_absolute)
    result = ''

    if path_absolute.nil?
      puts 'UtilsURL::to_path_relative arg is nil'
      return result
    end

    result = path_absolute

    result.gsub!(AppInfo.instance.host, '')
    result.gsub!('https://', '')
    result.gsub!('http://', '')

    result
  end

  public
  def self.download_file_and_put_to(url_source, path_destination, callback = nil)
    dir = File.dirname(path_destination)

    FileUtils.mkdir_p(dir)

    open(path_destination, 'wb') do |file|
      file << open(url_source).read

      unless callback.nil?
        callback.call
      end
    end

    nil
  end

end